(************************************************************************
*    This File is Part of the AHM Triton Tools                          *
*    for Borland Delphi and C++ Builder.                                *
*************************************************************************
* Copyright  1995-2000 Alexander H. Mehlhorn (AHM) and Tritontools.com *
* All Rights reserved.                                                  *
*                                                                       *
*    For more Information contact us at                                 *
*    E-Mail : support@tritontools.com                                   *
*    URL : http://www.tritontools.com                                   *
*                                                                       *
*    AHM is copyright by Alexander H. Mehlhorn                          *
*    All Parts of this Collection were developed,                       *
*    designed and implemented by AHM                                    *
*                                                                       *
*    Under no Circumstances may you distribute this file                *
*    in this or any other format. This File is supplied                 *
*    as Evaluation of Source only. No Delphi Components may be developed*
*    using extracts or subsets of this code without expressed permission*
*    by AHM.                                                            *
*                                                                       *
*************************************************************************)
unit AHMTSpeakerSound;

interface

uses
   Classes, Windows, Forms, AHMFreeware ;

type
   TAHMSpeakerSound = class(TComponent)
   private
      FAbout : TAHMAboutFreeStr;
      fenab,fdenab : Boolean;
      procedure Stop;
      procedure PlayS(Freq: Word);
      procedure SetPort(address, value: Word);
      function GetPort(address: Word): Word;
   protected
   public
      constructor Create( AOwner: TComponent ); override;
      destructor Destroy; override;
      procedure Delay(MSecs: Integer);
      procedure Sound(Freq: Word);
      procedure NoSound;
   published
      Property About : TAHMAboutFreeStr read FAbout write FAbout;
      Property SoundEnabled : Boolean read fenab write fenab;
      Property DelayEnabled : Boolean read fdenab write fdenab;
   end;

implementation

constructor TAHMSpeakerSound.Create( AOwner: TComponent );
begin
  fenab:=true;
  fdenab:=true;
  inherited Create( AOwner );
end;


destructor TAHMSpeakerSound.Destroy;
begin
  Stop;
  inherited Destroy;
end;


procedure TAHMSpeakerSound.Stop;
var
   wValue: Word;
begin
   wValue := GetPort($61);
   wValue := wValue and $FC;
   SetPort($61, wValue);
end;

procedure TAHMSpeakerSound.PlayS(Freq: Word);
var
   B: Word;
begin
   if Freq > 18 then begin
      Freq := Word(1193181 div LongInt(Freq));
      B := GetPort($61);
      if (B and 3) = 0 then begin
         SetPort($61, B or 3);
         SetPort($43, $B6);
      end;
      SetPort($42, Freq);
      SetPort($42, (Freq SHR 8));
   end;
end;

procedure TAHMSpeakerSound.SetPort(address, value: Word);
var
   bValue: Byte;
begin
   bValue := trunc(value and 255);
   asm
      mov DX, address
      mov AL, bValue
      out DX, AL
   end;
end;

function TAHMSpeakerSound.GetPort(address: Word): Word;
var
   bValue: Byte;
begin
   asm
      mov DX, address
      in  AL, DX
      mov bValue, AL
   end;
   result := bValue;
end;


procedure TAHMSpeakerSound.Delay(MSecs: Integer);
var FirstTickCount : DWord;
begin
   if fdenab then
   begin
     FirstTickCount:=GetTickCount;
     repeat
        Application.ProcessMessages;
     until ((GetTickCount-FirstTickCount) >= DWord(MSecs));
   end else Application.ProcessMessages;
end;

procedure TAHMSpeakerSound.Sound(Freq: Word);
begin
  if fenab then PlayS(Freq);
end;

procedure TAHMSpeakerSound.NoSound;
begin
   Stop;
end;

end.
